#ifndef GUARD_calibd_h
#define GUARD_calibd_h

#include "rng.h"
#include "info.h"
#include "tree.h"

const size_t minperbot=5;

#ifdef MPIBART
bool calibd(tree& x, xinfo& xi, pinfo& pi, RNG& gen, size_t numslaves);
#else
bool calibd(tree& x, xinfo& xi, dinfo& di, pinfo& pi, RNG& gen);
void calichgv(tree& x, xinfo& xi, dinfo& di, pinfo& pi, RNG& gen);
void updatecormat(tree::tree_p pertnode, xinfo& xi, std::vector<std::vector<double> >& chgv);
void normchgvrow(size_t row, std::vector<std::vector<double> >& chgv);
size_t getchgv(size_t oldv, std::vector<std::vector<double> >& chgv, RNG& gen);
#endif

#endif
