#ifndef GUARD_rotp_h
#define GUARD_rotp_h

#include "rng.h"
#include "info.h"
#include "tree.h"


bool calirotp(tree::tree_p tnew, tree& x, xinfo& xi, dinfo& di, pinfo& pi, RNG& gen);
void rotright(tree::tree_p n);
void rotleft(tree::tree_p n);
void reduceleft(tree::tree_p n, size_t v, size_t c);
void reduceright(tree::tree_p n, size_t v, size_t c);
void splitleft(tree::tree_p t, size_t v, size_t c);
void splitright(tree::tree_p t, size_t v, size_t c);
bool merge2(tree::tree_p tl, tree::tree_p tr, tree::tree_p t, size_t v, size_t c, RNG& gen);
bool merge3(tree::tree_p tl, tree::tree_p tr, size_t v, size_t c, int* nways);

// These ones support the rotate code, but could be generally useful too.
bool hasvcsplit(tree::tree_p t, size_t v, size_t c);
bool splitsonv(tree::tree_p t, size_t v);
bool splitsonv(tree::tree_p nl, tree::tree_p nr, size_t v);
bool isleaf(tree::tree_p t);
bool arenodesequal(tree::tree_p nl, tree::tree_p nr);
bool arenodesleafs(tree::tree_p nl, tree::tree_p nr);

#endif

